// pages/login/index.js
import { doLogin } from "../../utils/api/api";
Page({
  data: {
    username: '',
    password: '',
    open: false, //默认不显示密码
  },
  getVal(e) {
    let val = e.detail.value
    let type = e.target.dataset.type
    this.setData({
      [type]: val
    })
  },
  onSwitch() {
    this.setData({
      open: !this.data.open
    })
  },
  goLogin() {
    let {
      username,
      password,
    } = this.data
    let isVerify = this.verifyFun(username, password)
    if (!isVerify) {
      my.showToast({
        content: '请填写完整',
        type: 'none'
      })
      return
    }
    let data = {
      password,
      username
    }
    my.showLoading({
      content: '登录中',
    })
    doLogin(data).then(res => {
      my.hideLoading()
      my.setStorageSync({ key: 'userInfo', data: res.data })
      my.showToast({
        content: '登录成功',
        type: 'none',
        duration: 800,
        mask: true,
        success: function () {
          setTimeout(function () {
            my.switchTab({
              url: '/pages/home/index',
            })
          }, 800)
        }
      })
    }).catch(err => {
      my.hideLoading()
    })

  },
  verifyFun(username, password) {
    if (!username) {
      return false
    } else if (!password) {
      return false
    } else {
      return true
    }
  },
  onLoad() { },
});
