const { request } = require("../func/request");
// 用户登录
const doLogin = (data) => {
  return request({
    url: '/admin/doLogin',
    data: data,
    method: 'get',
    type: 'application/x-www-form-urlencoded',
    extra: 1
  })
}

// 用户登录 获取用户信息
const doGetInfo = data => {
  return request({
    url: "/api/appoint/getUserInfoByCode",
    data: data,
    method: "get",
    type: "application/x-www-form-urlencoded"
  });
};

// 接⼝实名⼊库
const userWithimage = data => {
  return request({
    url: "/api/v1/open/iotvsp/userwithimage/create",
    data: data,
    method: "post",
    type: "application/json",
    extra: 2
  });
};
// 支付宝用户一键入库
const userWithverified = data => {
  return request({
    url: "/api/v1/open/iotvsp/userwithverified/create",
    data: data,
    method: "post",
    type: "application/json",
    extra: 2
  });
};
// 接⼝匿名⼊库
const userWithanonymous = data => {
  return request({
    url: "/api/v1/open/iotvsp/userwithanonymous/create",
    data: data,
    method: "post",
    type: "application/json",
    extra: 2
  });
};
// 查询接口
const userPageList = data => {
  return request({
    url: "/admin/userPageList",
    data: data,
    method: "post",
    type: "application/json",
    extra: 1
  });
};
// 出库
const userDelete = data => {
  return request({
    url: "/api/v1/open/iotvsp/user/delete",
    data: data,
    method: "post",
    type: "application/json",
    extra: 2
  });
};

module.exports = {
  doLogin,
  doGetInfo,
  userWithverified,
  userWithimage,
  userWithanonymous,
  userPageList,
  userDelete
};
